<script setup lang="ts">
import { useAuthStore } from '@/stores/auth'
import { useStockStore } from '@/stores/stock'
import { useStockReceiptStore } from '@/stores/stockreceipt'
import type { Stock } from '@/types/Stock'
import type { StockReceipt } from '@/types/StockReceipt'
import type { User } from '@/types/User'
import { computed, nextTick, ref } from 'vue'
import { onMounted } from 'vue'
import type { VForm } from 'vuetify/components'

const stockStore = useStockStore()
const OrderReceiptStore = useStockReceiptStore()
const authStore = useAuthStore()
const headers = [
  {
    title: 'ID',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Receipt Date',
    key: 'receiptDate',
    value: 'receiptDate'
  },
  {
    title: 'Total Quantity',
    key: 'totalQuantity',
    value: 'totalQuantity'
  },
  {
    title: 'Total Price',
    key: 'totalPrice',
    value: (item: StockReceipt) => item.totalPrice.toFixed(2)
  },
  {
    title: 'EMP ID',
    key: 'employeeId',
    value: 'employeeId'
  },
  {
    title: 'EMP Name',
    key: 'employeeName',
    value: 'employeeName'
  },
  { title: '', key: 'actions', sortable: false }
]
const itemsPerPage = ref<any>(8)
const page = ref(1)
const search = ref('')
const dialog = ref(false)
const tab = ref('')
const pageCount = computed(() => {
  return Math.ceil(filteredOrderStock.value.length / itemsPerPage.value)
})
const refForm = ref<VForm | null>(null)
const form = ref(false)
const loading = ref(false)
const divStockReceiptItems = ref<HTMLElement | null>(null)
const dialogShowOrderReceiptItems = ref(false)
const filteredOrderStock = computed(() => {
  const searchValue = search.value;
  const currentUser = authStore.getCurrentUser();
  const branchId = currentUser?.branch.id;

  return OrderReceiptStore.stockReceiptsData.filter((orderReceipt) => {
    const formattedDate = formatDate(orderReceipt.receiptDate);
    const isOwner = currentUser?.roles.some((role) => role.name === 'Owner');

    if (isOwner) {
      return formattedDate.includes(searchValue);
    } else {
      const employeeBranchId = orderReceipt.employee?.branch?.id;
      const branchMatch = employeeBranchId === branchId;
      return formattedDate.includes(searchValue) && branchMatch;
    }
  });
});

function onSubmit() { }

function closeDialog() {
  dialog.value = false
  dialogShowOrderReceiptItems.value = false
  nextTick(() => {
    OrderReceiptStore.clearStockReceipt()
    OrderReceiptStore.clearStockReceiptItems()
  })
}

async function addReceiptItems(s: Stock) {
  const { valid } = await refForm.value!.validate()
  OrderReceiptStore.addStockReceiptItems(s)
  if (!valid) return
  nextTick(() => {
    if (divStockReceiptItems.value)
      divStockReceiptItems.value.scrollTo(0, divStockReceiptItems.value.scrollHeight)
  })
}

async function showOrderReceiptDialog(item: StockReceipt) {
  if (!item.id) return
  await OrderReceiptStore.getStockReceipt(item.id)
  dialogShowOrderReceiptItems.value = true
}

async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  if (OrderReceiptStore.stockReceiptItems.length === 0) return

  OrderReceiptStore.saveStockReceipt()
  closeDialog()
}

function formatDate(date: Date) {
  const formattedDate = new Date(date).toLocaleDateString('en-GB', {
    day: '2-digit',
    month: '2-digit',
    year: 'numeric'
  })
  return formattedDate
}
const filteredStock = computed(() => {
  const currentUser = authStore.getCurrentUser()
  const currentUserRole: User | null = authStore.getCurrentUser()
  const userId = currentUser ? currentUser.branch.id : null

  return stockStore.stocks.filter((stock) => {
    const nameMatch = stock.name.toUpperCase().includes(search.value.toUpperCase())
    const branchMatch = stock.branch?.id === userId

    if (currentUserRole!.roles.some((role) => role.name === 'Owner')) return nameMatch
    else return nameMatch && branchMatch
  })
})

onMounted(async () => {
  await stockStore.getStocks()
  await OrderReceiptStore.getStockReceipts()
})
</script>

<template>
  <v-tabs v-model="tab" align-tabs="center" color="deep-purple-accent-4">
    <div>
      <v-tab style="color: black" :to="{ name: 'stock' }">Stock</v-tab>
      <v-tab style="color: black" :to="{ name: 'check-stock' }">Check Stock</v-tab>
      <v-tab style="color: black" :to="{ name: 'order-stock' }">Order Stock</v-tab>
      <v-tab style="color: black" :to="{ name: 'graph-stock' }">Graph</v-tab>
      <v-tab style="color: black" :to="{ name: 'report-stock' }">Report</v-tab>
    </div>
  </v-tabs>

  <div class="text-center">
    <h1 style="text-align: left" class="ml-5">
      <v-icon icon="mdi-truck-delivery"></v-icon> Order Stock
    </h1>
  </div>
  <v-card-title class="d-flex align-center pe-2">
    <v-spacer></v-spacer>
    <v-btn style="background-color: saddlebrown; width: 200px; height: 45px" class="mr-4" @click="dialog = true">
      New Stock Receipt
    </v-btn>
    <v-text-field v-model="search" prepend-inner-icon="mdi-magnify" density="compact" label="Search" single-line flat
      hide-details variant="solo-filled"></v-text-field>
  </v-card-title>
  <v-data-table v-model:page="page" :headers="headers" :items="filteredOrderStock" :items-per-page="itemsPerPage">
    <template v-slot:bottom>
      <div class="text-center pt-2">
        <v-pagination v-model="page" :length="pageCount"></v-pagination>
      </div>
    </template>
    <template v-slot:[`item.receiptDate`]="{ value }">
      {{ formatDate(value) }}
    </template>
    <template v-slot:top>
      <!-- showOrderReceiptItems -->
      <v-dialog v-model="dialogShowOrderReceiptItems" width="600" height="800" persistent>
        <v-card>
          <v-card-title class="text-h5">OrderReceipt Item</v-card-title>
          <div style="margin: 10px">
            <v-spacer></v-spacer>
            <td>
              วันที่สั่งสินค้า:
              {{ formatDate(OrderReceiptStore.editedStockReceipt.receiptDate) }}
            </td>
            <v-spacer></v-spacer>
            <td>ผู้ซื้อสินค้า: {{ OrderReceiptStore.editedStockReceipt.employeeName }}</td>
            <v-spacer></v-spacer>
            <v-card-text>
              <v-table>
                <template v-slot:default>
                  <thead>
                    <tr>
                      <th>ID</th>
                      <th>Name</th>
                      <th>Quantity</th>
                      <th>Price</th>
                      <th>Total</th>
                    </tr>
                  </thead>
                  <tbody>
                    <tr v-for="(item, index) of OrderReceiptStore.editedStockReceipt
                      .stockReceiptItems!" :key="item.id">
                      <td>{{ index + 1 }}</td>
                      <td>{{ item.name }}</td>
                      <td>{{ item.quantity }}</td>
                      <td>{{ item.price.toFixed(2) }}</td>
                      <td>{{ item.value.toFixed(2) }}</td>
                    </tr>
                  </tbody>
                </template>
              </v-table>
              <br />
              <td>
                จำนวนสินค้าทั้งหมด: {{ OrderReceiptStore.editedStockReceipt.totalQuantity }} Unit
              </td>
              <v-spacer></v-spacer>
              <td>
                ยอดเงินรวม: {{ OrderReceiptStore.editedStockReceipt.totalPrice.toFixed(2) }} Baht
              </td>
            </v-card-text>
          </div>
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn color="red" variant="flat" style="width: 150px; height: 45px" @click="closeDialog">
              Close
            </v-btn>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </template>
    <template v-slot:[`item.actions`]="{ item }">
      <v-icon size="small" class="me-2" @click="showOrderReceiptDialog(item)">
        mdi-receipt-text</v-icon>
    </template>
  </v-data-table>

  <v-dialog v-model="dialog" persistent width="1440" height="800">
    <v-card>
      <v-form fast-fail ref="refForm" v-model="form" @submit.prevent="onSubmit" class="ml-5 mr-5 mt-5">
        <v-container>
          <v-row>
            <v-col cols="12" sm="12" md="4">
              <v-select v-model="OrderReceiptStore.editedStockReceiptItem.stock" label="Please Select Stock"
                :items="filteredStock" item-title="name" return-object>
              </v-select>
            </v-col>
            <v-col cols="12" sm="12" md="4">
              <v-text-field type="number" v-model.number="OrderReceiptStore.editedStockReceiptItem.quantity"
                :readonly="loading" :rules="[(v) => v >= 0]" class="mb-2" clearable label="QTY"
                placeholder="Enter your QTY"></v-text-field>
            </v-col>
            <v-col cols="12" sm="12" md="4">
              <v-text-field type="number" v-model.number="OrderReceiptStore.editedStockReceiptItem.price"
                :readonly="loading" :rules="[(v) => v >= 0]" class="mb-2" clearable label="Price"
                placeholder="Enter your Price"></v-text-field>
            </v-col>
          </v-row>
        </v-container>
        <v-card-actions aria-label="right" class="ml-5">
          <v-btn style="background-color: green; width: 150px; height: 45px"
            @click="addReceiptItems(OrderReceiptStore.editedStockReceiptItem.stock!)">ADD</v-btn>
          <v-btn style="background-color: red; width: 150px; height: 45px"
            @click="OrderReceiptStore.clearStockReceiptItems()">Cancel</v-btn>
        </v-card-actions>
      </v-form>
      <div ref="divStockReceiptItems" style="height: 400; overflow: auto">
        <v-sheet min-width="400" max-width="1800" height="400" elevation="4">
          <v-table>
            <template v-slot:default>
              <thead class="table-header">
                <tr>
                  <th>ID</th>
                  <th>Name</th>
                  <th>Quantity</th>
                  <th>Price</th>
                  <th>Total</th>
                  <th>Action</th>
                </tr>
              </thead>
              <tbody>
                <tr v-for="(item, index) of OrderReceiptStore.stockReceiptItems" :key="item.id">
                  <td>{{ index + 1 }}</td>
                  <td>{{ item.name }}</td>
                  <td>{{ item.quantity }}</td>
                  <td>{{ item.price.toFixed(2) }}</td>
                  <td>{{ (item.price * item.quantity).toFixed(2) }}</td>
                  <td>
                    <v-icon size="small" @click="() => {
                      OrderReceiptStore.removeStockReceiptItem(item)
                    }
                      ">mdi-delete</v-icon>
                  </td>
                </tr>
              </tbody>
            </template>
          </v-table>
        </v-sheet>
      </div>

      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn style="width: 150px; height: 45px" color="red" variant="flat" @click="closeDialog">
          Close
        </v-btn>
        <v-btn style="width: 150px; height: 45px" color="green" variant="flat" @click="save">
          Save
        </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<style scoped>
.v-btn {
  width: 235px;
  height: 90px;
  color: white;
  font-family: 'Kanit';
}

* {
  font-family: 'Kanit';
}

.left-half {
  height: 100%;
  background-color: #f0f0f0;
}

.right-half {
  height: 100%;
  background-color: grey;
}
</style>
